/* -*-c-*-
 *
 * $Id: algstuff.c,v 1.2 2004/04/08 01:36:21 mdw Exp $
 *
 * Support stuff for algorithms
 *
 * (c) 2001 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of the Perl interface to Catacomb.
 *
 * Catacomb/Perl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Catacomb/Perl is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Catacomb/Perl; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*----- Header files ------------------------------------------------------*/

#include "catacomb-perl.h"

/*----- Main code ---------------------------------------------------------*/

SV *findrand(const struct randtab *rt, const char *cls,
	     const char *name, SV *k)
{
  char *p;
  STRLEN len;
  p = SvPV(k, len);
  for (; rt->name; rt++) {
    if (strcmp(name, rt->name) == 0)
      return (MAKE(rt->rand(p, len), cls));
  }
  return (0);
}

void listrand(const struct randtab *rt)
{
  dSP;
  for (; rt->name; rt++)
    XPUSHs(sv_2mortal(newSVpvn((char *)rt->name, strlen(rt->name))));
}

/*----- That's all, folks -------------------------------------------------*/
