/* ---?---
 *
 * $Id: catacomb.xs,v 1.2 2004/04/08 01:36:21 mdw Exp $
 *
 * Main interface to Catacomb functionality
 *
 * (c) 2001 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of the Perl interface to Catacomb.
 *
 * Catacomb/Perl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Catacomb/Perl is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Catacomb/Perl; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "catacomb-perl.h"

MODULE = Catacomb PACKAGE = Catacomb

U32
const(name)
	char *name
	PREINIT:
	const struct consttab ct[] = {
#define C(x) { #x, x }
	  C(GRAND_CRYPTO),
	  C(PGEN_BEGIN), C(PGEN_TRY), C(PGEN_FAIL), C(PGEN_PASS),
	  C(PGEN_DONE), C(PGEN_ABORT),
#undef C
	  { 0,				0 },
	};
	CODE:
	RETVAL = findconst(ct, "Catacomb", name);
	OUTPUT:
	RETVAL

PROTOTYPES: DISABLE

INCLUDE: algorithms.xs
INCLUDE: mp.xs
INCLUDE: misc.xs
INCLUDE: pgen.xs
