/* -*-c-*-
 *
 * $Id: keystuff.c,v 1.2 2004/04/08 01:36:21 mdw Exp $
 *
 * Useful key-management functions
 *
 * (c) 2001 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of the Perl interface to Catacomb.
 *
 * Catacomb/Perl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Catacomb/Perl is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Catacomb/Perl; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*----- Header files ------------------------------------------------------*/

/*----- Data structures ---------------------------------------------------*/

/*----- Static variables --------------------------------------------------*/

/*----- Main code ---------------------------------------------------------*/

void warn_keyreporter(const char *file, int line, char *err, void *p)
{
  warn("%s:%i: keyfile error: %s", file, line, msg);
}

SV *keyerr(int rc)
{
  SV *sv;
  if (!rc)
    return (&PL_sv_yes);
  sv = perl_get_sv("Catacomb::Key::error", TRUE);
  sv_setiv(sv, rc);
  sv_setpv(sv, key_strerror(rc));
  SvIOK_on(sv);
  return (&PL_sv_undef);
}

/*----- That's all, folks -------------------------------------------------*/
